const {Router} = require("express");
const fs = require('fs');

module.exports = (app, parentRouter) => {
    const router = Router()
        router.use('/', (req, res, next) => {
            req.listData = Object.keys(app.cache.series).map(series => {
                return {
                    name: app.cache.series[series].name,
                    romaji: app.cache.series[series].romaji,
                    kanji: app.cache.series[series].kanji
                }}
            );
            return next();
        }, app.util.list(router, '')); //list all anime {id: {name: "", romaji: "", kanji: ""}}
    
    router.location = '/series';
    fs.readdirSync('./ani/v1/routes/series').filter(file => file.endsWith('.js'))
        .forEach(route => require(`./series/${route}`)(app, router)); //execute all router functions

    parentRouter.use('/series', router);
};