module.exports = {
    masterInit: (app) => {
        return (pushEdit, editCheck, router, model) => {
            return {
                string: async (req, res, name, match) => {
                    if (!req.params.id) {return;}
                    const series = await model.findOne({id: req.params.id.toLowerCase()});
                    if (!editCheck(series, req, res)) {return;}
                    if (!req.body[name]) {return res.status(400).send(`You did not provide a new ${name} in your body.`);}
                    if (!match(req.body[name])) {return res.status(400).send(`Your new ${name} is too long or contains illegal characters.`);}
                    try {
                        series[name] = req.body[name].trim();
                        pushEdit(`Updated ${name}`, req, series);
                        return series.save()
                            .then(() => res.send(`${name.charAt(0)}${name.slice(1)} updated.`))
                            .catch(() => res.status(500).send(`There was an error trying to update your ${name}. Please try again.`));
                    } catch {return res.status(500).send(`There was an error trying to update your ${name}. Please try again.`);}
                },

                stringWrap: (name, match) => {
                    const route = router.route(`/:id/${name}`);
                    route.patch(app.auth.token, app.auth.permsPass('series-approve'), async (req, res) => {
                        await this.string(req, res, name, match);
                    });
                    return route
                }
            }
        }
    }
}